Global jscrw=1024
Global jscrh=768

Graphics3D jscrw,jscrh,0,2
SeedRnd MilliSecs()

Global BoxSprite[1024]



campivot=CreatePivot()
cam=CreateCamera(campivot)
MoveEntity cam,50,50,50
PointEntity cam,campivot
AmbientLight 128,128,128
lamp=CreateLight(2,campivot)
MoveEntity lamp,100,90,150
LightRange lamp,50

ConvertBoxSprites()

Repeat
Cls
RenderWorld

TurnEntity campivot,0.1,0.2,0.3


UpdateWorld
Flip
Until KeyDown(1)



Function ConvertBoxSprites()
img=LoadImage("sprites.png")

LockBuffer ImageBuffer(img)

pixel=CreateCube()
ScaleMesh pixel,0.5,0.5,0.5

; Spritesheet Info
SpriteWidth=16
SpriteHeight=16

SpritesX=ImageWidth(img)/SpriteWidth
SpritesY=ImageHeight(img)/SpriteHeight


For sy=0 To SpritesY-1
For sx=0 To SpritesX-1	; For each sprite (8 x 8 spritesheet of 16x16 pixels
	ID=(sy*SpritesX)+sx
	BoxSprite[ID]=CreateMesh()
	For y=0 To SpriteHeight
	For x=0 To SpriteWidth
	
	cx#=Float(x)-(Float(SpriteWidth)/2.0)
	cy#=Float(y)-(Float(SpriteHeight)/2.0)
	cz=0
	
		argb=ReadPixelFast((sx*SpriteWidth)+x,(sy*SpriteHeight)+y,ImageBuffer(img))
		
		r=(argb And $00FF0000) Shr 16
		g=(argb And $0000FF00) Shr 8
		b=(argb And $000000FF)
		
		
		If r>4 Or g>4 Or b>4	; Assuming 0,0,0 = transparent
			tbrush=CreateBrush(r,g,b)
			PaintMesh pixel,tbrush
			PositionMesh pixel,cx,cy,cz
			AddMesh pixel,BoxSprite[ID]
			PositionMesh pixel,-cx,-cy,-cz
			FreeBrush tbrush
		EndIf
	Next
	Next
	
	MoveEntity BoxSprite[ID],Rnd(-32,32),Rnd(-32,32),Rnd(-32,32)
	RotateEntity BoxSprite[ID],Rnd(360),Rnd(360),Rnd(360)
	UpdateNormals BoxSprite[ID]
Next
Next

UnlockBuffer ImageBuffer(img)

FreeEntity pixel
End Function